<?php
/*
  $Id: ipn.php,v 0.4.1.0 beta 2007/02/18 07:08:00 Alex Li Exp $

  Copyright (c) 2007 AlexStudio
  Released under the GNU General Public License
    
*/

  chdir('../../../../');
  require('includes/application_top.php');
  require(DIR_WS_CLASSES . 'payment.php');
  $payment_modules = new payment(paypal_ec);

  $parameters = 'cmd=_notify-validate';

  foreach ($_POST as $key => $value) {
    $parameters .= '&' . $key . '=' . urlencode(stripslashes($value));
  }

  if (MODULE_PAYMENT_PAYPAL_EC_SERVER == 'Live') {
    $server = 'www.paypal.com';
  } else {
    $server = 'www.sandbox.paypal.com';
  }

  $fsocket = false;
  $curl = false;
  $result = false;

  if ( (PHP_VERSION >= 4.3) && ($fp = @fsockopen('ssl://' . $server, 443, $errno, $errstr, 30)) ) {
    $fsocket = true;
  } elseif (function_exists('curl_exec')) {
    $curl = true;
  } elseif ($fp = @fsockopen($server, 80, $errno, $errstr, 30)) {
    $fsocket = true;
  }

  if ($fsocket == true) {
    $header = 'POST /cgi-bin/webscr HTTP/1.0' . "\r\n" .
              'Host: ' . $server . "\r\n" .
              'Content-Type: application/x-www-form-urlencoded' . "\r\n" .
              'Content-Length: ' . strlen($parameters) . "\r\n" .
              'Connection: close' . "\r\n\r\n";

    @fputs($fp, $header . $parameters);

    $string = '';
    while (!@feof($fp)) {
      $res = @fgets($fp, 1024);
      $string .= $res;

      if ( ($res == 'VERIFIED') || ($res == 'INVALID') ) {
        $result = $res;

        break;
      }
    }

    @fclose($fp);
  } elseif ($curl == true) {
    $ch = curl_init();

    // For the poor souls on GoDaddy and the like, set the connection to go through their proxy
    if (trim(MODULE_PAYMENT_PAYPAL_EC_PROXY) != '') {
      curl_setopt($ch, CURLOPT_PROXYTYPE, CURLPROXY_HTTP);
      curl_setopt($ch, CURLOPT_PROXY, MODULE_PAYMENT_PAYPAL_EC_PROXY);
    }

    curl_setopt($ch, CURLOPT_URL, 'https://' . $server . '/cgi-bin/webscr');
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $parameters);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HEADER, false);
    curl_setopt($ch, CURLOPT_TIMEOUT, 30);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

    $result = curl_exec($ch);

    curl_close($ch);
  }
// BOF Debug Email for developing
  if (trim(MODULE_PAYMENT_PAYPAL_EC_DEBUG_EMAIL) != '' && MODULE_PAYMENT_PAYPAL_EC_SUCCESS_EMAIL == 'True') {
    $email_body = '$_POST:' . "\n\n";
    foreach ($_POST as $key => $value) {
      $email_body .= $key . '=' . $value . "\n";
    }
    $email_body .= "\n" . '$_GET:' . "\n\n";
    foreach ($_GET as $key => $value) {
      $email_body .= $key . '=' . $value . "\n";
    }
    tep_mail(STORE_OWNER, MODULE_PAYMENT_PAYPAL_EC_DEBUG_EMAIL, 'PayPal EC IPN Dump', $email_body, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
  }
// EOF Debug Email for developing
  if (tep_not_null($_GET['language'])) {
    include(DIR_WS_LANGUAGES . $_GET['language'] . '/' . FILENAME_CHECKOUT_PROCESS);
    $language_query = tep_db_query("select languages_id from " . TABLE_LANGUAGES . " where directory = '" . $_GET['language'] . "'");
    $language_array = tep_db_fetch_array($language_query);
    $language_id = $language_array['languages_id'];
  } else $language_id = $languages_id;
  // Check Transaction ID first!!
  switch ( $result ) {
    case 'VERIFIED':
      $result = 'Verified';
      $send_debug_email = false;
      break;
    default:
      $result = 'Invalid';
      $send_debug_email = true;
      break;
  }
  
  $txn_id = ( isset($_POST['parent_txn_id']) ? $_POST['parent_txn_id'] : (isset($_POST['txn_id']) ? $_POST['txn_id'] : '' ));
  if (!empty( $txn_id ) && preg_match('/^[a-z0-9]+$/i', $txn_id)) {
    // Fetch the order record
    $order_check = tep_db_query("select orders_id from " . TABLE_ORDERS_STATUS_HISTORY . " where comments like ('%" . $txn_id . "%')");
    if (tep_db_num_rows($order_check) > 0) {
      $order_ok = tep_db_fetch_array($order_check);
      $order_id = tep_db_prepare_input($order_ok['orders_id']);
      $order_query = tep_db_query("select customers_id, customers_name, customers_email_address, date_purchased, orders_status, currency, currency_value from " . TABLE_ORDERS . " where orders_id = '" . (int)$order_id . "'");
      $order = tep_db_fetch_array($order_query);

      // Update the order status
      $total_query = tep_db_query("select value from " . TABLE_ORDERS_TOTAL . " where orders_id = '" . (int)$order_id . "' and class = 'ot_total' limit 1");
      $total = tep_db_fetch_array($total_query);

      
      $comment_status = "[" . $_POST['payment_status'];

      if ( ($_POST['payment_status'] == 'Reversed') || ($_POST['payment_status'] == 'Refunded') ) {
        $comment_status .= ", reason: " . $_POST['reason_code'];
      } else {
        if ($_POST['payment_status'] == 'Pending') {
        $comment_status .= ", reason: " . $_POST['pending_reason'];
        }
        $comment_status .= " (PayPal account:" . ucfirst($_POST['payer_status']);
      }
      $comment_status .= "; " . $_POST['mc_currency'] . " " . $_POST['mc_gross'] . ")";

      $order_status_id = DEFAULT_ORDERS_STATUS_ID;

      // Check the Completed mc_gross amount with order total, allowing a small discrepancy for rounding issue.
      $decimal_query = tep_db_query("select decimal_places from " . TABLE_CURRENCIES . " where value = 1");
      $decimal_array = tep_db_fetch_array($decimal_query);
      $decimal_places = $decimal_array['decimal_places'] >= 2 ? 2 : $decimal_array['decimal_places'];
      $discrepancy = 2;
      for ($i = 0; $i < $decimal_places; $i++) {
        $discrepancy /= 10;
      }
      if ((abs($total['value'] - $_POST['mc_gross']/$order['currency_value']) <= $discrepancy) && $_POST['payment_status'] == 'Completed') {

        if (MODULE_PAYMENT_PAYPAL_EC_ORDER_STATUS_ID > 0) {
          $order_status_id = MODULE_PAYMENT_PAYPAL_EC_ORDER_STATUS_ID;
        }
        if (isset($_POST['address_status']) && trim($_POST['address_status']) != '') $comment_status .= "]\n" . MODULE_PAYMENT_PAYPAL_EC_TEXT_ADDRESS_STATUS . $_POST['address_status'];
        else $comment_status .= "]";

      // ** Total amount mismatch ** Notify Store Owner
      } else if (abs($total['value'] - abs($_POST['mc_gross'])/$order['currency_value']) > $discrepancy) {

        $orders_statuses = array();
        $orders_status_array = array();
        $orders_status_query = tep_db_query("select orders_status_id, orders_status_name from " . TABLE_ORDERS_STATUS . " where language_id = '" . (int)$language_id . "'");
        while ($orders_status = tep_db_fetch_array($orders_status_query)) {
          $orders_statuses[] = array('id' => $orders_status['orders_status_id'],
                                     'text' => $orders_status['orders_status_name']);
          $orders_status_array[$orders_status['orders_status_id']] = $orders_status['orders_status_name'];
        }
        $comment_status .= "]\n" . MODULE_PAYMENT_PAYPAL_EC_TEXT_NO_MATCH . "\n" . MODULE_PAYMENT_PAYPAL_EC_TEXT_ADDRESS_STATUS . $_POST['address_status'];
        $decimal = 2;
        if ($order['currency'] == 'JPY') $decimal = 0;
        $email = STORE_NAME . "\n" .
                 EMAIL_SEPARATOR . "\n" .
                 EMAIL_TEXT_ORDER_NUMBER . ' ' . $order_id . "\n" .
                 EMAIL_TEXT_DATE_ORDERED . ' ' . tep_date_long($order['date_purchased']) . "\n\n" . sprintf(EMAIL_TEXT_STATUS_UPDATE_ERROR, $orders_status_array[$order_status_id]) . "\n" .
                 $comment_status . "\n\n" .
                 "OrderTotal= " . $order['currency'] . " " . round($total['value'] * $order['currency_value'], $decimal);
        tep_mail(STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS, 'PayPal EC IPN Error', $email, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);

      // ** Payment not Completed **
      } else {

        switch($_POST['payment_status']) {
          case 'Failed':
          case 'Denied':
          case 'Refunded':
          case 'Reversed':
            if (MODULE_PAYMENT_PAYPAL_EC_CANCELLED_ORDER_STATUS_ID > 0) {
              $order_status_id = MODULE_PAYMENT_PAYPAL_EC_CANCELLED_ORDER_STATUS_ID;
            }
            break;
          default:
            break;
        }
        if (isset($_POST['address_status']) && trim($_POST['address_status']) != '') $comment_status .= "]\n" . MODULE_PAYMENT_PAYPAL_EC_TEXT_ADDRESS_STATUS . $_POST['address_status'];
        else $comment_status .= "]";
      }

      // Only notify customers if updated from Pending to Completed
      if ($order_status_id == MODULE_PAYMENT_PAYPAL_EC_ORDER_STATUS_ID && $order['orders_status'] != MODULE_PAYMENT_PAYPAL_EC_ORDER_STATUS_ID) {
        $orders_statuses = array();
        $orders_status_array = array();
        $orders_status_query = tep_db_query("select orders_status_id, orders_status_name from " . TABLE_ORDERS_STATUS . " where language_id = '" . (int)$language_id . "'");
        while ($orders_status = tep_db_fetch_array($orders_status_query)) {
          $orders_statuses[] = array('id' => $orders_status['orders_status_id'],
                                     'text' => $orders_status['orders_status_name']);
          $orders_status_array[$orders_status['orders_status_id']] = $orders_status['orders_status_name'];
        }
        
        $email = STORE_NAME . "\n" .
                 EMAIL_SEPARATOR . "\n" .
                 EMAIL_TEXT_ORDER_NUMBER . ' ' . $order_id . "\n" .
                 EMAIL_TEXT_INVOICE_URL . ' ' . tep_href_link(FILENAME_ACCOUNT_HISTORY_INFO, 'order_id=' . $order_id, 'SSL', false, false) . "\n" .
                 EMAIL_TEXT_DATE_ORDERED . ' ' . tep_date_long($order['date_purchased']) . "\n\n" . sprintf(EMAIL_TEXT_STATUS_UPDATE, $orders_status_array[$order_status_id]);
        tep_mail($order['customers_name'], $order['customers_email_address'], EMAIL_TEXT_SUBJECT, $email, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);

        $customer_notified = '1'; 
// Customer notification email ends here ***************************************
      } else {
        $customer_notified = '0';
      }

      $sql_data_array = array('orders_id' => (int)$order_id,
                              'orders_status_id' => $order_status_id,
                              'date_added' => 'now()',
                              'customer_notified' => $customer_notified,
                              'comments' => "PayPal IPN " . $result . "\n" . $comment_status);
      tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);

      tep_db_query("update " . TABLE_ORDERS . " set orders_status = '" . $order_status_id . "', last_modified = now() where orders_id = '" . (int)$order_id . "'");
    }
  } else {
    $send_debug_email = true;
  }
////******** Invalid transaction ID, send out debug email
  if ($send_debug_email && trim(MODULE_PAYMENT_PAYPAL_EC_DEBUG_EMAIL) != '' ) {
    $email_body = '$_POST:' . "\n\n";
    foreach ($_POST as $key => $value) {
      $email_body .= $key . '=' . $value . "\n";
    }
    $email_body .= "\n" . '$_GET:' . "\n\n";
    foreach ($_GET as $key => $value) {
      $email_body .= $key . '=' . $value . "\n";
    }
    tep_mail(STORE_OWNER, MODULE_PAYMENT_PAYPAL_EC_DEBUG_EMAIL, 'PayPal Express Checkout IPN Invalid Response', $email_body, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
  }
  require('includes/application_bottom.php');
?>